<?php

namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\ApontamentoService;
use FM\Traits\TResponse;

class ApontamentoController extends FMCrud {
    
    use TResponse;
    protected $ApontamentoService;
   
    public function __construct($crudService, $environment, ApontamentoService $ApontamentoService) {
        parent::__construct($crudService, $environment);
        $this->ApontamentoService = $ApontamentoService;
    }
    
    public function setNewRegister(Request $request, Response $response) {
        try {
            $data = $this->ApontamentoService->setNewRegister($request->getParameters());
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getUltimoRegistro(DTO\Request $request, DTO\Response $response) {
        try {
            $data = $this->ApontamentoService->getUltimoRegistro();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function optionLunch(Request $request, Response $response) {
        try {
                $data = $this->ApontamentoService->optionLunch();
                $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getApontamentos(Request $request, Response $response) {
        try {
            $data = $this->ApontamentoService->getApontamentos();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function setAbsence(Request $request, Response $response) {
        try {
            $data = $this->ApontamentoService->setAbsence($request->getParameters());
            $this->sendResponse($data, 200);
        }  catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
        
    }
    
    public function setLastAppointment(DTO\Request $request, DTO\Response $response) {
        try {
            $data = $this->ApontamentoService->setLastAppointment($request->getParameters());
            $this->sendResponse($data, 200);
        }  catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
?>