<?php

namespace FM\Service;

use FM\Factory\FotoTarefaAgendFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use FM\Traits\TFileUpload;

class FotoTarefaAgendService {
    
    use TFileUpload;

    protected $FotoTarefaAgendFactory;
    protected $Environment;
    protected $newCode;

    public function __construct (FotoTarefaAgendFactory $FotoTarefaAgendFactory, Environment $Environment, NewCode $newCode) {
        $this->FotoTarefaAgendFactory = $FotoTarefaAgendFactory;
        $this->Environment = $Environment;
        $this->newCode = $newCode;
    }   
    
    public function anexarFoto($dados){
        
        $nrorg = $this->Environment->getNrOrg();
        $operador = $this->Environment->getCdOperador();
        
        $file = $this->uploadImages($dados['IMAGEM'], $nrorg);

        foreach($file as $image){
             $this->FotoTarefaAgendFactory->salvarImagem(array(
                 'NRFOTOTAREFAAGEND' => $this->newCode->getCodeByTableName("FCM_FOTOTAREFAAGEND", $nrorg, 1, 10, true),
                 'NRTAREFAAGEND' => intval($dados['NRTAREFA']),
                 'DSFOTOTAREFAAGEND' => $image['DS'],
                 'NRORG' => $nrorg,
                 'CDOPERINCLUSAO' => $operador,
                 'NRORGINCLUSAO' => $nrorg,
                 'CDOPERULTATU' => $operador,
                 'NRORGULTATU' => $nrorg,
                 'DSTYPE' => $image['DSTYPE'],
                 'NRSIZE' => $image['NRSIZE']
             ));
        }
    }
    
    public function getFoto($dados){
        return $this->FotoTarefaAgendFactory->getFoto(array(
            'NRTAREFAAGEND' => $dados['NRTAREFA'],
        ));
    }
    
    public function deleteFoto($dados){
        return $this->FotoTarefaAgendFactory->deleteFoto(array(
            'NRTAREFAAGEND' => $dados['NRTAREFA'],
            'NRFOTOTAREFAAGEND' => $dados['NRFOTOTAREFA'],
        ));
    }

    public function getDocumentoFileServer($urlArquivo, $nrorg) {
        $header = array (
            "apiKey: " . $this->fileServerApiKeys[$nrorg]
        );
        
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $urlArquivo);
        curl_setopt($ch, CURLOPT_POST, false);
        curl_setopt($ch, CURLOPT_HTTPHEADER, $header);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 0);
        curl_setopt($ch, CURLOPT_TIMEOUT, 90);

        $resultado = curl_exec($ch);
        $error     = curl_error($ch);
        curl_close($ch);

        if (!empty($error)) {
            throw new \Exception($error);
        }

        if (strpos($resultado, "404 Not Found") !== false) {
            //throw new \Exception($resultado);
            return false;
        }
        else {
            return $resultado;
        }
    }
}

?>
